﻿homepageApp.factory('CESInterface', function($http, $q) {
    var browseToDataset = function (datasetName, subsetName) {
        var Dataset = {
            DatasetName: datasetName,
            SubsetName: subsetName
        };

        $http({
            method: 'POST',
            url: "http://cesservicehost/Dataset/BrowseTo",
            data: Dataset
        });
    };
   
    return {
        BrowseToTable: function(tableName) {
            browseToDataset(tableName, "");
        },
        
        DisplayRecord: function(recordName) {
            $http({
                method: 'POST',
                url: "http://cesservicehost/Record/Display",
                data: recordName
            });
        },
        
        ChangeDatabase: function () {
            $http({
                method: 'POST',
                url: "http://cesservicehost/Database/Change"
            });
        },

        GetDatasetNames: function() {
            //Create promise
            var deferred = $q.defer();

            $http({
                method: 'GET',
                url: "http://cesservicehost/Dataset/DatasetNames"
            }).success(function(data, status, headers, config) {
                deferred.resolve(data);
            }).error(function(data, status, headers, config) {
                deferred.reject(status);
            });

            return deferred.promise;
        },

        BrowseToUrl: function (url) {
            var link = {
                Url: url
            };

            $http({
                method: 'POST',
                url: "http://cesservicehost/BrowseToUrl",
                data: link
            });
        },
        
        GetSelectedDatasetTitle: function() {
            var deferred = $q.defer();

            $http({
                method: 'GET',
                url: "http://cesservicehost/Dataset/Selected"
            }).success(function(data, status, headers, config) {
                deferred.resolve(data);
            }).error(function(data, status, headers, config) {
                deferred.reject(status);
            });

            return deferred.promise;
        }
    };
});